c File:         %M%     
c Last Update:  %E% %U% 
c Version:      %R%.%L% 
c
c...This s/r anneals the lattice for one cycle(?)
c
      subroutine group_energy(size, orient, i, j, k,
     >            ilow, iup, jlow, jup, klow, kup, 
     >            splay, twist, bend, saddlesplay, field, ierr)
c
      implicit none
c
c...passed variables
c
      integer             size(3)
      double precision    orient(3,size(1),size(2),size(3))
      integer             i, j, k
      integer             ilow, iup, jlow, jup, klow, kup 
      double precision    splay, twist, bend, saddlesplay, field
      integer             ierr
c
c...local variables
c
      double precision    sp, tw, be, sa, fi
      double precision    NOTUSED(3)
#include "elastic_constants.inc"
c
c..central cell (initialises splay, twist, bend etc)
c
      call energy(orient(1,i,j,k), 
     >             orient(1,ilow, j, k), orient(1,iup, j, k),
     >             orient(1,i, jlow, k), orient(1,i, jup, k),
     >             orient(1,i, j, klow), orient(1,i, j, kup),
     >             1, 2, 1, 2, 1, 2, 
     >             splay, twist, bend, saddlesplay, ierr)
c
c...Field energy for central cell
c
      call field_energy(orient(1,i,j,k), field, ierr)
c
c...six neighbouring cells
c
      call energy(orient(1,ilow,j,k), 
     >             NOTUSED, orient(1,i,j,k),
     >             orient(1,ilow,jlow,k), orient(1,ilow,jup,k),
     >             orient(1,ilow,j,klow), orient(1,ilow,j,kup),
     >             2, 2, 1, 2, 1, 2, 
     >             sp, tw, be, sa, ierr)
      splay = splay + sp
      twist = twist + tw
      bend  = bend  + be
      saddlesplay = saddlesplay + sa
c
      call energy(orient(1,iup,j,k), 
     >             orient(1,i,j,k), NOTUSED,
     >             orient(1,iup,jlow,k), orient(1,iup,jup,k),
     >             orient(1,iup,j,klow), orient(1,iup,j,kup),
     >             1, 1, 1, 2, 1, 2, 
     >             sp, tw, be, sa, ierr)
      splay = splay + sp
      twist = twist + tw
      bend  = bend  + be
      saddlesplay = saddlesplay + sa
c
      call energy(orient(1,i,jlow,k), 
     >             orient(1,ilow,jlow,k), orient(1,iup,jlow,k),
     >             NOTUSED, orient(1,i,j,k),
     >             orient(1,i,jlow,klow), orient(1,i,jlow,kup),
     >             1, 2, 2, 2, 1, 2, 
     >             sp, tw, be, sa, ierr)
      splay = splay + sp
      twist = twist + tw
      bend  = bend  + be
      saddlesplay = saddlesplay + sa
c
      call energy(orient(1,i,jup,k), 
     >             orient(1,ilow,jup,k), orient(1,iup,jup,k),
     >             orient(1,i,j,k), NOTUSED,
     >             orient(1,i,jup,klow), orient(1,i,jup,kup),
     >             1, 2, 1, 1, 1, 2, 
     >             sp, tw, be, sa, ierr)
      splay = splay + sp
      twist = twist + tw
      bend  = bend  + be
      saddlesplay = saddlesplay + sa
c
      call energy(orient(1,i,j,klow), 
     >             orient(1,ilow,j,klow), orient(1,iup,j,klow),
     >             orient(1,i,jlow,klow), orient(1,i,jup,klow),
     >             NOTUSED, orient(1,i,j,k),
     >             1, 2, 1, 2, 2, 2, 
     >             sp, tw, be, sa, ierr)
      splay = splay + sp
      twist = twist + tw
      bend  = bend  + be
      saddlesplay = saddlesplay + sa
c
      call energy(orient(1,i,j,kup), 
     >             orient(1,ilow,j,kup), orient(1,iup,j,kup),
     >             orient(1,i,jlow,kup), orient(1,i,jup,kup),
     >             orient(1,i,j,k), NOTUSED,
     >             1, 2, 1, 2, 1, 1, 
     >             sp, tw, be, sa, ierr)
      splay = splay + sp
      twist = twist + tw
      bend  = bend  + be
      saddlesplay = saddlesplay + sa
c
      return
c
      end
